<?php

declare(strict_types=1);

namespace Dedi\SyliusMailAdminPlugin\Renderer\Adapter;

use Dedi\SyliusMailAdminPlugin\Event\DediMailAdminEvent;
use Sylius\Component\Mailer\Model\EmailInterface;
use Sylius\Component\Mailer\Renderer\Adapter\AbstractAdapter;
use Sylius\Component\Mailer\Renderer\Adapter\AdapterInterface;
use Sylius\Component\Mailer\Renderer\RenderedEmail;
use Symfony\Contracts\EventDispatcher\EventDispatcherInterface;

class EmailTwigAdapter extends AbstractAdapter
{
    private AdapterInterface $decoratedEmailTwigAdapter;
    private EventDispatcherInterface $eventDispatcher;

    public function __construct(
        AdapterInterface $decoratedEmailTwigAdapter,
        EventDispatcherInterface $eventDispatcher
    ) {
        $this->decoratedEmailTwigAdapter = $decoratedEmailTwigAdapter;
        $this->eventDispatcher = $eventDispatcher;
    }

    public function render(EmailInterface $email, array $data = []): RenderedEmail
    {
        /** @var DediMailAdminEvent $event */
        $event = $this->eventDispatcher->dispatch(new DediMailAdminEvent($email, $data));

        return $this->decoratedEmailTwigAdapter->render($event->getEmail(), $event->getData());
    }
}
